<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Morpion</title>
    <style>
        #game {
            border: 2px solid yellow;
            width: 310px;
        }

        #game div {
            border: 1px solid #000;
            width: 100px;
            height: 100px;
            float: left;
        }
    </style>
</head>

<body>
    <div id="game">
        <div></div>
        <div></div>
        <div></div>
        <div></div>
        <div></div>
        <div></div>
        <div></div>
        <div></div>
        <div></div>
    </div>

    <script>
        class Game {
            constructor() {
                this.board = document.querySelector("#game");
                this.cells = document.querySelectorAll("#game div");
                this.players = ["X", "O"];
                this.playerTurn = 0;
                this.winningPositions = [
                    [0, 1, 2],
                    [3, 4, 5],
                    [6, 7, 8],
                    [0, 3, 6],
                    [1, 4, 7],
                    [2, 5, 8],
                    [0, 4, 8],
                    [2, 4, 6]
                ];
            }

            start() {
                this.board.addEventListener("click", event => {
                    let cellClicked = event.target;

                    if(cellClicked.innerHTML) {
                        return;
                    }

                    cellClicked.innerHTML = this.players[this.playerTurn];
                    this.detectWin();
                    this.nextTurn();
                })
            }

            nextTurn() {
                this.playerTurn = this.playerTurn ? 0 : 1;
            }

            detectWin() {

                this.winningPositions.forEach(winningPosition => {
                    let aligned = [0, 0];

                    this.cells.forEach((cell, i) => {
                        if (cell.innerHTML === "") {
                            return;
                        }

                        let player = this.players.indexOf(cell.innerHTML);
                        if (winningPosition.includes(i)) {
                            aligned[player]++;
                        }
                    })

                    console.log(winningPosition, aligned)

                    if (aligned[0] === 3 || aligned[1] === 3) {
                        this.end();
                    }
                });
            }

            end() {
                alert("Victoire !");

                this.cells.forEach(cell => {
                    cell.innerHTML = "";
                })
            }
        }

        let game = new Game();

        game.start();
    </script>
</body>

</html>